/*
 * Filename    : arch/mips/vr41xx/commom/mr2a_sleep.S
 * Author      : Jackal Chuang
 * Email       : ct_chuang@coventive.com
 * Create Date : Wed Step 19 2002
 * 
 * Modify Date : 
 * 
 * Description : - save_regs() 
 *                 save VR4121 GPR[0..31] and CP0 register into main menory.
 *		 - wakeup_restore_regs()
 *                 restort VR4121 GPR[0..31] and CPO register.
 * Source      : Copyright (c) 2002 Coventive
 */


#include <asm/regdef.h>
#include <asm/mipsregs.h>

#include "sleep_offset.h"


		.globl save_regs_arr
save_regs_arr:  .word 0   

		.text
/***********************************************************************
 * function : save_regs()
 ***********************************************************************/
		.globl  save_regs
		.align  2
		.type   save_regs,@function
		.ent    save_regs
save_regs:
	    	.frame  sp,SR_SIZE,ra
		.set    mips3		
		.set    noat
		.set    push
		
		lui     k1,%hi(save_regs_arr)
		lw      k1,%lo(save_regs_arr)(k1)
		
		move	k0, sp
		move    sp, k1
/*
 * GPR[29,0,2,3,4..7,25,28,29,31] and CP0
 */
 		sw	k0, SR_R29(sp)
		
                sw	$3, SR_R3(sp)
		sw	$0, SR_R0(sp)
		mfc0	$3, CP0_INDEX
		sw	$2, SR_R2(sp)
		sw	$3, SR_CP0_INDEX(sp)
		sw	$4, SR_R4(sp)
		mfc0	$3, CP0_ENTRYLO0
		sw	$5, SR_R5(sp)
		sw	$3, SR_CP0_ENTRYLO0(sp)
		sw	$6, SR_R6(sp)
		mfc0	$3, CP0_ENTRYLO1
		sw	$7, SR_R7(sp)
		sw	$3, SR_CP0_ENTRYLO1(sp)
		sw	$25,SR_R25(sp)
		mfc0    $3, CP0_CONTEXT
		sw	$28,SR_R28(sp)
		sw      $3, SR_CP0_CONTEXT(sp)
		sw	$31,SR_R31(sp)
/*
 * GPR[1] (at) and CP0 register.
 */
		mfc0    $3, CP0_PAGEMASK
		sw	$1, SR_R1(sp)
		sw      $3, SR_CP0_PAGEMASK(sp)		
/*
 * GPR[8..15,24] (tmp) and CP0 register.
 */
		sw	$8, SR_R8(sp)
		mfc0    $3, CP0_WIRED
		sw	$9, SR_R9(sp)
		sw	$3, SR_CP0_WIRED(sp)
		sw	$10,SR_R10(sp)		
		mfc0    $3, CP0_BADVADDR
		sw	$11,SR_R11(sp)
		sw      $3, SR_CP0_BADVADDR(sp)
		sw	$12,SR_R12(sp)
		mfc0    $3, CP0_COUNT
		sw	$13,SR_R13(sp)
		sw      $3, SR_CP0_COUNT(sp)
		sw	$14,SR_R14(sp)
		mfc0    $3, CP0_ENTRYHI
		sw	$15,SR_R15(sp)
		sw      $3, SR_CP0_ENTRYHI(sp)
                sw	$24,SR_R24(sp)
/*
 * GPR[16..23,30] (static) and CP0 register.
 */
 		mfc0    $3, CP0_COMPARE
		sw	$16,SR_R16(sp)
		sw      $3, SR_CP0_COMPARE(sp)
		sw	$17,SR_R17(sp)
		mfc0    $3, CP0_STATUS
		sw	$18,SR_R18(sp)
		sw      $3, SR_CP0_STATUS(sp)
		sw	$19,SR_R19(sp)
		mfc0    $3, CP0_CAUSE
		sw	$20,SR_R20(sp)
		nop
		sw      $3, SR_CP0_CAUSE(sp)
		nop
		sw	$21,SR_R21(sp)
		mfc0    $3, CP0_EPC
		sw	$22,SR_R22(sp)
		nop
		sw      $3, SR_CP0_EPC(sp)
		nop
		sw	$23,SR_R23(sp)
		mfc0    $3, CP0_PRID
		sw	$30,SR_R30(sp)
		sw      $3, SR_CP0_PRID(sp)
		nop
		mfc0    $3, CP0_CONFIG
		nop
		sw      $3, SR_CP0_CONFIG(sp)
		nop
		mfc0    $3, CP0_WATCHLO
		nop
		sw      $3, SR_CP0_WATCHLO(sp)
	        nop     
		mfc0    $3, CP0_WATCHHI
		nop
		sw      $3, SR_CP0_WATCHHI(sp)
		nop
		mfc0    $3, CP0_XCONTEXT
		nop
		sw      $3, SR_CP0_XCONTEXT(sp)
		nop
		mfc0    $3, CP0_TAGLO
		nop
		sw      $3, SR_CP0_TAGLO(sp)
		nop
		mfc0    $3, CP0_TAGHI
		nop
		sw      $3, SR_CP0_TAGHI(sp)
		nop
		mfc0    $3, CP0_ERROREPC
		nop
		sw      $3, SR_CP0_ERROREPC(sp)
		nop
		mfhi    $3		
		nop
		nop
		sw      $3, SR_HI(sp)
		nop
		mflo    $3
		nop
		nop
		sw      $3, SR_LO(sp)
		
		nop
		nop
		
/* 
 * Road MR2A register 
 */
      	      	lui      k0, 0xaa00

		lhu      k1, 0x0260(k0)
		sh       k1, MR2A_CMUCLKMSK(sp)
		nop
		nop

		lhu      k1, 0x0044(k0)
		sh       k1, MR2A_GIUPIOD(sp)
		nop
		nop
		
		lhu      k1, 0x005c(k0)
		sh       k1, MR2A_PDECGPIOSEL(sp)
		nop
		nop

		lw      $3, SR_R3(sp)
		lw      sp, SR_R29(sp)
		
                j       ra

		.set    pop
		
		.end    save_regs
		.size   save_regs,.-save_regs

/***********************************************************************
 * function : wakeup_restore_regs()
 ***********************************************************************/
		.globl  wakeup_restore_regs
		.align  5
		.type   wakeup_restore_regs,@function
		.ent    wakeup_restore_regs
wakeup_restore_regs:
	    	.frame  sp,SR_SIZE,ra
		.set    mips3
		.set	noat
 		.set    push
		.set    reorder
		
		
		lui     k1,%hi(save_regs_arr)
		lw      k1,%lo(save_regs_arr)(k1)
		
		move    sp,k1
		
		
		li      $8 , 0xab000100
		 
		lh      $9 , 0($8)
		ori     $9 , $9 , 0x3000
		sh      $9 , 0($8)
		    
		lh      $9 , 4($8)
		andi    $9 , $9 , 0xcfff
	        ori     $9 , $9 , 0x3000
		sh      $9 , 4($8)
			

/* 
 * Restore MR2-A register 
 */
                lui     k0, 0xaa00

                lhu     k1, MR2A_CMUCLKMSK(sp)
		sh      k1, 0x0260(k0)
		nop
		nop

                lhu     k1, MR2A_GIUPIOD(sp)
		sh      k1, 0x0044(k0)
		nop
		nop
		
                lhu     k1, MR2A_PDECGPIOSEL(sp)
		sh      k1, 0x005c(k0)
		nop
		nop
/*
 * GPR[31,28,25,2,3,4..7]
 */
		lw      $31, SR_R31(sp)
		lw      $28, SR_R28(sp)
		lw      k1,  SR_CP0_STATUS(sp)
		lw      $25, SR_R25(sp)
		lw      $7,  SR_R7(sp)
		mtc0    k1,  CP0_STATUS
		lw      k1,  SR_CP0_EPC(sp)
		lw      $6,  SR_R6(sp)
		lw	$5,  SR_R5(sp)
		mtc0    k1,  CP0_EPC
		lw	$4,  SR_R4(sp)
		lw	$3,  SR_R3(sp)
		lw	$2,  SR_R2(sp)
/*
 * Restore CP0 register about TLB
 */
   	        lw      k1,  SR_CP0_INDEX(sp)
		nop
		nop
		mtc0    k1,  CP0_INDEX
		lw      k1,  SR_CP0_ENTRYLO0(sp)
		nop
		nop
		mtc0    k1,  CP0_ENTRYLO0
		lw      k1,  SR_CP0_ENTRYLO1(sp)
		nop
		nop
		mtc0    k1,  CP0_ENTRYLO1
		lw      k1,  SR_CP0_PAGEMASK(sp)
		nop
		nop
		mtc0    k1,  CP0_PAGEMASK
		lw      k1,  SR_CP0_ENTRYHI(sp)
		nop
		nop
                mtc0    k1,  CP0_ENTRYHI

/*
 *  Restore CP0 other register 
 */
               lw       k1,  SR_CP0_CONTEXT(sp)
	       nop
	       nop
	       mtc0     k1,  CP0_CONTEXT
               lw       k1,  SR_CP0_WIRED(sp)
	       nop
	       nop
	       mtc0     k1,  CP0_WIRED
	       lw       k1,  SR_CP0_XCONTEXT(sp)
	       nop
	       nop
	       mtc0     k1,  CP0_XCONTEXT
	       lw       k1,  SR_CP0_COMPARE(sp)
	       nop
	       nop
	       mtc0     k1,  CP0_COMPARE
	       lw       k1,  SR_CP0_CONFIG(sp)
	       nop
	       nop
	       mtc0     k1,  CP0_CONFIG
	       lw       k1,  SR_CP0_WATCHLO(sp)
	       nop
	       nop
	       mtc0     k1,  CP0_WATCHLO
	       lw       k1,  SR_CP0_WATCHHI(sp)
	       nop
	       nop
	       mtc0     k1,  CP0_WATCHHI
	       lw       k1,  SR_CP0_TAGLO(sp)
	       nop
	       nop
	       mtc0     k1,  CP0_TAGLO
	       lw       k1,  SR_CP0_TAGHI(sp)
	       nop
	       nop
	       mtc0     k1,  CP0_TAGHI
	       nop
	       nop
	       mtc0     $0,  CP0_COUNT
	       nop
	       nop
	       mtc0     $0,  CP0_CAUSE
/*
 * Restore GPR[1]
 */
		lw	$1,  SR_R1(sp)

		lw	$24, SR_LO(sp)
		lw	$8, SR_R8(sp)
		lw	$9, SR_R9(sp)
		mtlo	$24
		lw	$24, SR_HI(sp)
		lw	$10, SR_R10(sp)
		lw	$11, SR_R11(sp)
		mthi	$24
		lw	$12, SR_R12(sp)
		lw	$13, SR_R13(sp)
		lw	$14, SR_R14(sp)
		lw	$15, SR_R15(sp)
		lw	$24, SR_R24(sp)
		
		lw	$16, SR_R16(sp)
		lw	$17, SR_R17(sp)
		lw	$18, SR_R18(sp)
		lw	$19, SR_R19(sp)
		lw	$20, SR_R20(sp)
		lw	$21, SR_R21(sp)
		lw	$22, SR_R22(sp)
		lw	$23, SR_R23(sp)
		lw	$30, SR_R30(sp)

		lw	sp,  SR_R29(sp)
		nop
		nop
		jr    ra
		nop
		nop
                .set    reorder
		
		.end    wakeup_restore_regs
		.size   wakeup_restore_regs,.-wakeup_restore_regs
