/*==========================================================*/
/*	Copyright (C) ROAD Corporation. 2000					*/
/*	ROAD Corporation CONFIDENTIAL AND PROPRIETARY			*/
/*	All rights reserved by ROAD Corporation.				*/
/*	Mr2H3.h 11/16/2000										*/
/*==========================================================*/


/*==========================================================*/
/*		MR2FPGA I/OAhX									*/
/*==========================================================*/
#define LCDAREA 		0xa0000000

// GIU
#define MR2GIUDIR			(unsigned short *)( 0x0a000040 + LCDAREA )
#define MR2GIUPIOD			(unsigned short *)( 0x0a000044 + LCDAREA )
#define MR2GIUINTSTAT		(unsigned short *)( 0x0a000048 + LCDAREA )
#define MR2GIUINTEN			(unsigned short *)( 0x0a00004c + LCDAREA )
#define MR2GIUINTTYP		(unsigned short *)( 0x0a000050 + LCDAREA )
#define MR2GIUINTALSEL		(unsigned short *)( 0x0a000054 + LCDAREA )
#define MR2GIUINTHTSEL		(unsigned short *)( 0x0a000058 + LCDAREA )
#define MR2PDECGPIOSEL		(unsigned short *)( 0x0a00005c + LCDAREA )

// PGU
#define MR2TMOD 			(unsigned short *)( 0x0a000080 + LCDAREA )
#define MR2TINT 			(unsigned short *)( 0x0a000084 + LCDAREA )
#define MR2TINTM			(unsigned short *)( 0x0a000086 + LCDAREA )
#define MR2TCNT0			(unsigned short *)( 0x0a000088 + LCDAREA )
#define MR2TLD0 			(unsigned short *)( 0x0a00008a + LCDAREA )
#define MR2TGRA0			(unsigned short *)( 0x0a00008c + LCDAREA )
#define MR2TGRB0			(unsigned short *)( 0x0a00008e + LCDAREA )
#define MR2TGRC0			(unsigned short *)( 0x0a000090 + LCDAREA )
#define MR2TCON0			(unsigned short *)( 0x0a000092 + LCDAREA )
#define MR2TSEL0			(unsigned short *)( 0x0a000094 + LCDAREA )
#define MR2TCAL0			(unsigned short *)( 0x0a000096 + LCDAREA )
#define MR2TCNT1			(unsigned short *)( 0x0a000098 + LCDAREA )
#define MR2TLD1 			(unsigned short *)( 0x0a00009a + LCDAREA )
#define MR2TGRA1			(unsigned short *)( 0x0a00009c + LCDAREA )
#define MR2TGRB1			(unsigned short *)( 0x0a00009e + LCDAREA )
#define MR2TGRC1			(unsigned short *)( 0x0a0000a0 + LCDAREA )
#define MR2TCON1			(unsigned short *)( 0x0a0000a2 + LCDAREA )
#define MR2TSEL1			(unsigned short *)( 0x0a0000a4 + LCDAREA )
#define MR2TCAL1			(unsigned short *)( 0x0a0000a6 + LCDAREA )
#define MR2PGUFIFOCNT		(unsigned short *)( 0x0a0000c0 + LCDAREA )
#define MR2PGUFIFODAT		(unsigned short *)( 0x0a0000c2 + LCDAREA )

// RTC
#define MR2SEC1 			(unsigned short *)( 0x0a000200 + LCDAREA )
#define MR2SEC10			(unsigned short *)( 0x0a000202 + LCDAREA )
#define MR2MIN1 			(unsigned short *)( 0x0a000204 + LCDAREA )
#define MR2MIN10			(unsigned short *)( 0x0a000206 + LCDAREA )
#define MR2HOU1 			(unsigned short *)( 0x0a000208 + LCDAREA )
#define MR2HOU10			(unsigned short *)( 0x0a00020a + LCDAREA )
#define MR2DAY1 			(unsigned short *)( 0x0a00020c + LCDAREA )
#define MR2DAY10			(unsigned short *)( 0x0a00020e + LCDAREA )
#define MR2MON1 			(unsigned short *)( 0x0a000210 + LCDAREA )
#define MR2MON10			(unsigned short *)( 0x0a000212 + LCDAREA )
#define MR2YEA1 			(unsigned short *)( 0x0a000214 + LCDAREA )
#define MR2YEA10			(unsigned short *)( 0x0a000216 + LCDAREA )
#define MR2WEE				(unsigned short *)( 0x0a000218 + LCDAREA )
#define MR2REGD 			(unsigned short *)( 0x0a00021A + LCDAREA )
#define MR2REGE 			(unsigned short *)( 0x0a00021C + LCDAREA )
#define MR2REGF 			(unsigned short *)( 0x0a00021E + LCDAREA )

// RTC ==============================================================
#define RegF				(0x0a00021e + 0xa0000000)
#define RegE				(0x0a00021c + 0xa0000000)
#define RegD				(0x0a00021a + 0xa0000000)
#define Wee					(0x0a000218 + 0xa0000000)
#define Yea10				(0x0a000216 + 0xa0000000)
#define Yea1				(0x0a000214 + 0xa0000000)
#define Mon10				(0x0a000212 + 0xa0000000)
#define Mon1				(0x0a000210 + 0xa0000000)
#define Day10				(0x0a00020e + 0xa0000000)
#define Day1				(0x0a00020c + 0xa0000000)
#define Hou10				(0x0a00020a + 0xa0000000)
#define Hou1				(0x0a000208 + 0xa0000000)
#define Min10				(0x0a000206 + 0xa0000000)
#define Min1				(0x0a000204 + 0xa0000000)
#define Sec10				(0x0a000202 + 0xa0000000)
#define Sec1				(0x0a000200 + 0xa0000000)
//====================================================================

// FCU
#define MR2FCU_CMDST		(unsigned short *)( 0x0a000240 + LCDAREA )
#define MR2FCU_RBX			(unsigned short *)( 0x0a000242 + LCDAREA )
#define MR2FCU_AD			(unsigned short *)( 0x0a000244 + LCDAREA )
#define MR2FCU_CNT			(unsigned short *)( 0x0a000246 + LCDAREA )
#define MR2FCU_DATA			(unsigned short *)( 0x0a000248 + LCDAREA )

// CMU
#define MR2CMUCLKMSK		(unsigned short *)( 0x0a000260 + LCDAREA )
#define MR2CMUSRST			(unsigned short *)( 0x0a000262 + LCDAREA )
#define MR2CMUCLKSEL		(unsigned short *)( 0x0a000264 + LCDAREA )

// ICU
#define MR2SYSINT1REG		(unsigned short *)( 0x0a000270 + LCDAREA )
#define MR2GIUINTREG		(unsigned short *)( 0x0a000272 + LCDAREA )
#define MR2MSYSINT1REG		(unsigned short *)( 0x0a000274 + LCDAREA )
#define MR2MGIUINTREG		(unsigned short *)( 0x0a000276 + LCDAREA )

// PDEC
#define MR2PDEC0LL			(unsigned short *)( 0x0a0002c0 + LCDAREA )
#define MR2PDEC0LH			(unsigned short *)( 0x0a0002c2 + LCDAREA )
#define MR2PDEC0HL			(unsigned short *)( 0x0a0002c4 + LCDAREA )
#define MR2PDEC0HH			(unsigned short *)( 0x0a0002c6 + LCDAREA )
#define MR2PDEC1LL			(unsigned short *)( 0x0a0002c8 + LCDAREA )
#define MR2PDEC1LH			(unsigned short *)( 0x0a0002ca + LCDAREA )
#define MR2PDEC1HL			(unsigned short *)( 0x0a0002cc + LCDAREA )
#define MR2PDEC1HH			(unsigned short *)( 0x0a0002ce + LCDAREA )
#define MR2PDEC2LL			(unsigned short *)( 0x0a0002d0 + LCDAREA )
#define MR2PDEC2LH			(unsigned short *)( 0x0a0002d2 + LCDAREA )
#define MR2PDEC2HL			(unsigned short *)( 0x0a0002d4 + LCDAREA )
#define MR2PDEC2HH			(unsigned short *)( 0x0a0002d6 + LCDAREA )
#define MR2PDEC3LL			(unsigned short *)( 0x0a0002d8 + LCDAREA )
#define MR2PDEC3LH			(unsigned short *)( 0x0a0002da + LCDAREA )
#define MR2PDEC3HL			(unsigned short *)( 0x0a0002dc + LCDAREA )
#define MR2PDEC3HH			(unsigned short *)( 0x0a0002de + LCDAREA )

// CSI
#define MR2CSI_MODEREG		(unsigned short *)( 0x0a0002e0 + LCDAREA )
#define MR2CSI_BRGREG		(unsigned short *)( 0x0a0002e2 + LCDAREA )
#define MR2CSI_SOTBREG		(unsigned short *)( 0x0a0002e4 + LCDAREA )
#define MR2CSI_SIRBEREG 	(unsigned short *)( 0x0a0002e6 + LCDAREA )
#define MR2CSI_FIFOCNTREG	(unsigned short *)( 0x0a0002e8 + LCDAREA )
#define MR2CSI_STATUSREG	(unsigned short *)( 0x0a0002ea + LCDAREA )
#define MR2CSI_SIGNALSTREG	(unsigned short *)( 0x0a0002ec + LCDAREA )
#define MR2CSI_INTSTREG 	(unsigned short *)( 0x0a0002ee + LCDAREA )
#define MR2CSI_INTMREG		(unsigned short *)( 0x0a0002f0 + LCDAREA )

// LCDC
#define MR2D_VL1			(unsigned short *)( 0x0a000402 + LCDAREA )

#define VRAM_start		(0x0a300000 + 0xa0000000)
#define VRAM_end		(0x0a313880 + 0xa0000000)		/* VRAM End Address */

// UART
#define F65SIU	(0xAA000220)		/*@FPGA@RS232CAhX*/
#define VR412XDSIU	(0xAB0001A0)
/*==========================================================*/
/*		H3]p	G[R[h							*/
/*==========================================================*/

// INITIAL
#define INITIAL_ERR			0xE000

// AISC
#define ASIC_DATA_ERR		0xE100

// SDRAM
#define SDRAM_DATA1_ERR 	0xE200
#define SDRAM_DATA0_ERR 	0xE201

// FROM
#define FROM_ID_ERR			0xE300
#define FROM_DATA1_ERR		0xE301
#define FROM_DATA0_ERR		0xE302
#define FROM_VPEN_ERR		0xE303
#define FROM_RB_ERR			0xE304
#define FROM_ERASE_ERR		0xE305

// LCD
#define LCD_VRAM_ERR		0xE400
#define LCD_MODE_ERR		0xE401
#define LCD_RESET_ERR		0xE402

// MATRIX_KEY
#define KEY_DATA_ERR		0xE500

// TOUCH_PANEL
#define TP_DATA_ERR			0xE600

// IRDA
#define IRDA_SEND_ERR		0xE700
#define IRDA_RECV_ERR		0xE701

// SS_WIRELESS
#define SS_DATA_ERR			0xE800

// BUZZER
#define BUZ_ERR 			0xE900

// SCANER
#define SCA_SEND_ERR		0xEA00
#define SCA_RECV_ERR		0xEA01
#define SCA_INIT_ERR		0xEA02

// POWER
#define POW_BATSTS_OFF_ERR	0xEB00
#define POW_BATSW_OFF_ERR	0xEB01
#define POW_RSTSW_OFF_ERR	0xEB02
#define POW_PWSW_ON_ERR 	0xEB03
#define POW_RSTSW_ON_ERR	0xEB04
#define NMI_RSTSW_ON_ERR	0xEB05
#define NMI_BATSTS_OFF_ERR	0xEB06
#define NMI_BATSW_OFF_ERR	0xEB07
#define POW_DRAMCMP_ERR 	0xEB08

// CPU_RESET
#define CPU_RESET_ERR		0xEC00

/*==========================================================*/
/*		MR2WS2]p	G[R[h							*/
/*==========================================================*/

// GIU
#define GIUDEFERR			0x0101
#define GIURWERR			0x0102
#define GIUINTERR			0x0103

// PGU
#define PGUDEFERR			0x0201
#define PGURWERR			0x0202
#define PGUFIFOERR			0x0203

// RTC
#define RTCBUSYERR			0x0301

// FCU
#define FCUDEFERR			0x0401
#define FCURWERR			0x0402
#define FCURESETERR			0x0403
#define FCUIDERR			0x0404
#define FCUERASEERR			0x0405
#define FCUREADERR			0x0406
#define FCUPROERR			0x0407

// CMU
#define CMUDEFERR			0x0501
#define CMURWERR			0x0502
#define CMURESETERR			0x0503

// ICU
#define ICUDEFERR			0x0601
#define ICURWERR			0x0602

// PDEC
#define PDECDEFERR			0x0701
#define PDECRWERR			0x0702

// CSI
#define CSIDEFERR			0x0801
#define CSIRWERR			0x0802
#define CSITRGERR			0x0803
#define CSIOVERERR			0x0804
#define CSIINTERR			0x0805



