/*
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 2002 by Jalen Yang jalen@coventive.com
 */

#ifndef __ASM_MR2A_H
#define __ASM_MR2A_H

#include <asm/addrspace.h>

#ifndef _LANGUAGE_ASSEMBLY
#define __preg8		(volatile unsigned char*)
#define __preg16	(volatile unsigned short*)
#define __preg32	(volatile unsigned int*)
#else
#define __preg8
#define __preg16
#define __preg32
#endif


/* Programmable Decoder */

#define MR2A_PDEC0LL	__preg16(KSEG1 + 0x0A0002C0)	/* Sets lower address for the lowest limit of programmable decoder 0 */
#define MR2A_PDEC0LH	__preg16(KSEG1 + 0x0A0002C2)	/* Sets higher address for the lowest limit of programmable decoder 0 */
#define MR2A_PDEC0HL	__preg16(KSEG1 + 0x0A0002C4)	/* Sets lower address for the highest limit of programmable decoder 0 */
#define MR2A_PDEC0HH	__preg16(KSEG1 + 0x0A0002C6)	/* Sets higher address for the highest limit of programmable decoder 0 */
#define MR2A_PDEC1LL	__preg16(KSEG1 + 0x0A0002C8)	/* Sets lower address for the lowest limit of programmable decoder 1 */
#define MR2A_PDEC1LH	__preg16(KSEG1 + 0x0A0002CA)	/* Sets higher address for the lowest limit of programmable decoder 1 */
#define MR2A_PDEC1HL	__preg16(KSEG1 + 0x0A0002CC)	/* Sets lower address for the highest limit of programmable decoder 1 */
#define MR2A_PDEC1HH	__preg16(KSEG1 + 0x0A0002CE)	/* Sets higher address for the highest limit of programmable decoder 1 */
#define MR2A_PDEC2LL	__preg16(KSEG1 + 0x0A0002D0)	/* Sets lower address for the lowest limit of programmable decoder 2 */
#define MR2A_PDEC2LH	__preg16(KSEG1 + 0x0A0002D2)	/* Sets higher address for the lowest limit of programmable decoder 2 */
#define MR2A_PDEC2HL	__preg16(KSEG1 + 0x0A0002D4)	/* Sets lower address for the highest limit of programmable decoder 2 */
#define MR2A_PDEC2HH	__preg16(KSEG1 + 0x0A0002D6)	/* Sets higher address for the highest limit of programmable decoder 2 */
#define MR2A_PDEC3LL	__preg16(KSEG1 + 0x0A0002D8)	/* Sets lower address for the lowest limit of programmable decoder 3 */
#define MR2A_PDEC3LH	__preg16(KSEG1 + 0x0A0002DA)	/* Sets higher address for the lowest limit of programmable decoder 3 */
#define MR2A_PDEC3HL	__preg16(KSEG1 + 0x0A0002DC)	/* Sets lower address for the highest limit of programmable decoder 3 */
#define MR2A_PDEC3HH	__preg16(KSEG1 + 0x0A0002DE)	/* Sets higher address for the highest limit of programmable decoder 3 */

#endif /* __ASM_MR2A_H */