#ifndef SP_H
#define SP_H /* SP_H */
#include <asm/vr4121/vr4121.h>
#include <asm/ioctl.h>
#define SOUND_VERSION	0x001
#define SP_MAJOR	13
#define SP_IOC_MAGIC	SP_MAJOR
#define SP_NAME 	"speaker"
#define SP_MIXER_MINOR	0
#define VOLUME_H 2
#define VOLUME_L 1
#define VOLUME_OFF 0

#define SP_OUT_PG0 0
#define SP_OUT_PG1 1
#define SP_OUT_PG2 2
#define SP_OUT_PG3 3
#define SP_OUT_PG4 4
#define SP_OUT_PG5 5


#define BARCODE_READ 0
#define KEYBOARD_IN 1
#define DATA_RECEIVER 2
#define ALARM 3


#define CONFIG_GIO14_NOT_USE_PULL_UP_DOWN() \
	*VR41XX_GIUUSEUPDN &= ~VR41XX_GIUPIODL_GPIO14

#define CONFIG_GIO14_IS_OUTPIN() \
	*VR41XX_GIUIOSELL |=  VR41XX_GIUPIODL_GPIO14

#define GPIO14_H() \
	*VR41XX_GIUPIODL |=  VR41XX_GIUPIODL_GPIO14
#define GPIO14_L() \
	*VR41XX_GIUPIODL &= ~VR41XX_GIUPIODL_GPIO14

#define VOL_H() GPIO14_H()
#define VOL_L() GPIO14_L()
#define VOL_OFF()  WRITE_TCAL0(0x4000)

typedef enum
{
 volume_off,
 volume_lo,
 volume_hi
}VOLUME;
typedef struct BUZZER_t
{
 unsigned int freq;
 unsigned int buzz_on_time;
 unsigned int buzz_off_time;
 unsigned int times;
 VOLUME volume;
}BUZZER;

typedef struct 
{
	unsigned int freq[20];
	unsigned int duration; 
	unsigned int note;
	VOLUME volume;
}OSE_BUZZER;

#define SP_IOC_FREQ 0
#define SP_IOC_VOL 1
#define SP_IOC_STATUS 2
#define SP_IOC_NO 3
#define SP_IOC_SHOW 4
#define SP_IOC_TIME 5
#define SP_IOC_STOP 6
#define SP_IOC_USER_BUZZER 7
#define SP_IOC_SYSTONE_BARCODE 8
#define SP_IOC_SYSTONE_KEYBOARD 9
#define SP_IOC_SYSTONE_RECEIVE 10
#define SP_IOC_SYSTONE_ALARM 11
#define SP_IOC_OSE_BUZZER 12

#define SP_NO_BARCODE 0
#define SP_NO_KEY 1
#define SP_NO_SERVER 2
#define SP_NO_BUZZER 3

#endif /* SP_H */
