/*
 * FILE NAME
 *	include/asm-mips/vr41xx/roadht.h
 *
 * BRIEF MODULE DESCRIPTION
 *	Include file for ROAD_HT.
 *
 * Copyright 2002 COVENTIVE
 */
#ifndef __ROAD_HT_H
#define __ROAD_HT_H

#include <asm/addrspace.h>
#include <asm/vr41xx.h>

/*
 * Board specific address mapping
 */
#define VR41XX_ISA_MEM_BASE		0x00000000
#define VR41XX_ISA_MEM_SIZE		0xffffffff

/* VR41XX_ISA_IO_BASE includes offset from real base. */
#define VR41XX_ISA_IO_BASE		0x14000000
#define VR41XX_ISA_IO_SIZE		0x04000000

#define IO_PORT_BASE			KSEG1ADDR(VR41XX_ISA_IO_BASE)
#define IO_PORT_RESOURCE_START		0
#define IO_PORT_RESOURCE_END		VR41XX_ISA_IO_SIZE
#define IO_MEM_RESOURCE_START		VR41XX_ISA_MEM_BASE
#define IO_MEM_RESOURCE_END		(VR41XX_ISA_MEM_BASE + VR41XX_ISA_MEM_SIZE)

#endif /* __ROAD_HT_H */
